'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var $ = _interopDefault(require('zepto-modules'));
require('zepto-modules/selector');
var El = _interopDefault(require('el.js'));
var esRaf = require('es-raf');
var akasha = _interopDefault(require('akasha'));
var HanzoAnalytics = _interopDefault(require('hanzo-analytics'));

// src/zepto.coffee

// src/header-menu.coffee

$(function() {
  var $scrollableArea, $window;
  $window = $(window);
  $window.on('DOMContentLoaded scroll', function(e) {
    if ($window.scrollTop() > 10) {
      return $('header').first().addClass('undocked').removeClass('docked');
    } else {
      return $('header').first().removeClass('undocked').addClass('docked');
    }
  });
  $scrollableArea = $('main');
  return $scrollableArea.on('DOMContentLoaded scroll', function(e) {
    if ($scrollableArea.scrollTop() > 10) {
      return $('header').first().addClass('undocked').removeClass('docked');
    } else {
      return $('header').first().removeClass('undocked').addClass('docked');
    }
  });
});

// src/header-menu-complex.coffee
var HeaderMenuComplex,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

HeaderMenuComplex = (function(superClass) {
  extend(HeaderMenuComplex, superClass);

  function HeaderMenuComplex() {
    return HeaderMenuComplex.__super__.constructor.apply(this, arguments);
  }

  HeaderMenuComplex.prototype.tag = 'header-menu-complex';

  HeaderMenuComplex.prototype.html = '<yield/>';

  HeaderMenuComplex.prototype.menuToShow = '';

  HeaderMenuComplex.prototype.slideDirection = '';

  HeaderMenuComplex.prototype.init = function() {
    var hideMenu;
    HeaderMenuComplex.__super__.init.apply(this, arguments);
    hideMenu = this.hideMenu.bind(this);
    this.on('mount', (function(_this) {
      return function() {
        _this.showMenu({
          target: $('[data-menu-title]')[0]
        });
        _this.menuToShow = '';
        return $(document).on('mousemove', hideMenu);
      };
    })(this));
    return this.on('unmount', function() {
      return $(document).off('mousemove', hideMenu);
    });
  };

  HeaderMenuComplex.prototype.showMenu = function(e) {
    var $el, $menu, $menuToShow, $wrapper, first, isLeftOf, isRightOf, left, title;
    this.slideDirection = '';
    $el = $(e.target);
    if ($el[0] == null) {
      return;
    }
    first = this.menuToShow === '';
    title = $el.data('menu-title');
    if (!first) {
      isRightOf = $('[data-menu-title="' + this.menuToShow + '"]').offset().left < $el.offset().left;
      isLeftOf = $('[data-menu-title="' + this.menuToShow + '"]').offset().left > $el.offset().left;
      if (isRightOf) {
        this.slideDirection = 'right';
      } else if (isLeftOf) {
        this.slideDirection = 'left';
      }
    }
    this.menuToShow = title;
    $menu = $el.closest(this.tag);
    $menuToShow = $menu.find('[data-menu="' + this.menuToShow + '"] .menu-content');
    left = $el.offset().left - $menu.offset().left + (($el.width() - $menuToShow.width()) / 2);
    $wrapper = $menu.find('.menu-wrapper');
    if (first) {
      $wrapper.css({
        transition: $wrapper.css('transition') + ', transform 0s'
      });
      esRaf.raf(function() {
        return $wrapper.css({
          transition: null
        });
      });
    }
    $wrapper.css({
      transform: 'translateX(' + left + 'px)',
      width: $menuToShow.width() + 'px',
      height: $menuToShow.height() + 'px'
    });
    return console.log('Showing ' + $el.data('menu-title'));
  };

  HeaderMenuComplex.prototype.hideMenu = function(e) {
    if (!$('[data-menu-title]:hover')[0] && !$('[data-menu-title]:focus')[0] && !$('.menu-wrapper:hover')[0]) {
      this.menuToShow = '';
      console.log('Hiding ' + e);
      return this.scheduleUpdate();
    }
  };

  return HeaderMenuComplex;

})(El.View);

HeaderMenuComplex.register();

var HeaderMenuComplex$1 = HeaderMenuComplex;

// src/header-menu-mobile.coffee
var HeaderMenuMobile,
  extend$1 = function(child, parent) { for (var key in parent) { if (hasProp$1.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$1 = {}.hasOwnProperty;

HeaderMenuMobile = (function(superClass) {
  extend$1(HeaderMenuMobile, superClass);

  function HeaderMenuMobile() {
    return HeaderMenuMobile.__super__.constructor.apply(this, arguments);
  }

  HeaderMenuMobile.prototype.tag = 'header-menu-mobile';

  HeaderMenuMobile.prototype.html = '<yield/>';

  HeaderMenuMobile.prototype.init = function() {
    return HeaderMenuMobile.__super__.init.apply(this, arguments);
  };

  return HeaderMenuMobile;

})(El.View);

HeaderMenuMobile.register();

var HeaderMenuMobile$1 = HeaderMenuMobile;

// src/header-menu-simple.coffee
var HeaderMenuSimple,
  extend$2 = function(child, parent) { for (var key in parent) { if (hasProp$2.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$2 = {}.hasOwnProperty;

HeaderMenuSimple = (function(superClass) {
  extend$2(HeaderMenuSimple, superClass);

  function HeaderMenuSimple() {
    return HeaderMenuSimple.__super__.constructor.apply(this, arguments);
  }

  HeaderMenuSimple.prototype.tag = 'header-menu-simple';

  HeaderMenuSimple.prototype.html = '<yield/>';

  HeaderMenuSimple.prototype.init = function() {
    return HeaderMenuSimple.__super__.init.apply(this, arguments);
  };

  return HeaderMenuSimple;

})(El.View);

HeaderMenuSimple.register();

var HeaderMenuSimple$1 = HeaderMenuSimple;

// src/privacy-popup.coffee
var PrivacyPopup,
  extend$3 = function(child, parent) { for (var key in parent) { if (hasProp$3.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$3 = {}.hasOwnProperty;

PrivacyPopup = (function(superClass) {
  extend$3(PrivacyPopup, superClass);

  function PrivacyPopup() {
    return PrivacyPopup.__super__.constructor.apply(this, arguments);
  }

  PrivacyPopup.prototype.tag = 'privacy-popup';

  PrivacyPopup.prototype.html = '<yield/>';

  PrivacyPopup.prototype.init = function() {
    return PrivacyPopup.__super__.init.apply(this, arguments);
  };

  PrivacyPopup.prototype.accept = function() {
    return akasha.set('site.privacy.accepted', true);
  };

  PrivacyPopup.prototype.accepted = function() {
    return !!(akasha.get('site.privacy.accepted'));
  };

  return PrivacyPopup;

})(El.View);

PrivacyPopup.register();

var PrivacyPopup$1 = PrivacyPopup;

// src/utils.coffee
var debounce;

debounce = function(func, wait, immediate) {
  var timeout;
  if (wait == null) {
    wait = 10;
  }
  if (immediate == null) {
    immediate = false;
  }
  timeout = null;
  return function() {
    var args, callNow, context, later;
    context = this;
    args = arguments;
    later = function() {
      timeout = null;
      if (!immediate) {
        return func.apply(context, args);
      }
    };
    callNow = immediate && !timeout;
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
    if (callNow) {
      return func.apply(context, args);
    }
  };
};

// src/_content-annotator.coffee
var Annotator, get$targetAndSelector, getScrollPosition, getSelector, isElementInViewport;

isElementInViewport = function(rect) {
  return rect.top >= 0 && rect.left >= 0 && rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && rect.right <= (window.innerWidth || document.documentElement.clientWidth);
};

getScrollPosition = function() {
  var isCSS1Compat, supportPageOffset, x, y;
  supportPageOffset = window.pageXOffset !== void 0;
  isCSS1Compat = (document.compatMode || "") === "CSS1Compat";
  x = supportPageOffset ? window.pageXOffset : isCSS1Compat ? document.documentElement.scrollLeft : document.body.scrollLeft;
  y = supportPageOffset ? window.pageYOffset : isCSS1Compat ? document.documentElement.scrollTop : document.body.scrollTop;
  return [x, y];
};

get$targetAndSelector = function(e) {
  var $parent, $target, _selector, target;
  $target = $(e.target);
  if (!$target.is('[itemscope]')) {
    $parent = $target.closest('[itemscope]');
    if ($parent[0]) {
      $target = $parent;
    }
  }
  target = $target[0];
  _selector = getSelector(target);
  return [$target, _selector];
};

getSelector = function(el) {
  var $el, _selector, clas, id, selector$$1, selectors;
  $el = $(el);
  selector$$1 = el.tagName;
  id = $el.attr('id');
  if (id) {
    selector$$1 += '#' + id;
  }
  clas = $el.attr('class');
  if (clas) {
    selector$$1 += '.' + clas.replace(/\s/g, '.');
  }
  selectors = [selector$$1];
  _selector = el._selector;
  if (_selector == null) {
    $el.parents().each(function(i, p) {
      var $p;
      $p = $(p);
      selector$$1 = p.tagName;
      id = $p.attr('id');
      if (id) {
        selector$$1 += '#' + id;
      }
      clas = $p.attr('class');
      if (clas) {
        selector$$1 += '.' + clas.replace(/\s/g, '.');
      }
      return selectors.push(selector$$1);
    });
    _selector = selectors.reverse().join(' > ');
    el._selector = _selector;
  }
  return _selector;
};

Annotator = (function() {
  Annotator.prototype.root = null;

  function Annotator(root) {
    var $link, $node, $p, $root, addedLinkEls, content, json, level, link, node, nodes, p, text, textContent, topLevel, written;
    this.root = root != null ? root : $(document.createElement('DIV'));
    addedLinkEls = [];
    $root = $(this.root);
    json = {
      '@type': 'WebsiteSection',
      type: this.tag,
      id: $root.attr('id'),
      "class": $root.attr('class'),
      content: []
    };
    $root.attr('itemscope', '').attr('itemtype', 'WebsiteSection');
    $root.prepend('<meta itemprop="type" content="' + this.tag + '"/>');
    if ($root.attr('id')) {
      $root.prepend('<meta itemprop="id" content="' + $root.attr('id') + '"/>');
    }
    if ($root.attr('class')) {
      $root.prepend('<meta itemprop="class" content="' + $root.attr('class') + '"/>');
    }
    content = {
      '@type': 'WebsiteContent',
      content: []
    };
    written = false;
    topLevel = 5;
    $root.find('h1, h2, h3, h4, small').each(function(i, node) {
      switch (node.tagName) {
        case 'H1':
          topLevel = Math.min(1, topLevel);
          break;
        case 'H2':
          topLevel = Math.min(2, topLevel);
          break;
        case 'H3':
          topLevel = Math.min(3, topLevel);
          break;
        case 'H4':
          topLevel = Math.min(4, topLevel);
          break;
        case 'SMALL':
          topLevel = Math.min(6, topLevel);
          break;
        default:
          topLevel = Math.min(5, topLevel);
      }
      return console.log('tag', node.tagName, topLevel);
    });
    $root.find('a[href]').each(function(i, node) {
      var $node;
      $node = $(node);
      $node.attr('itemscope', '').attr('itemtype', 'WebsiteLink').attr('itemprop', 'url');
      $node.prepend('<meta itemprop="text" content="' + $node.text() + '"/>');
      if ($node.attr('id')) {
        $node.prepend('<meta itemprop="id" content="' + $node.attr('id') + '"/>');
      }
      if ($node.attr('class')) {
        return $node.prepend('<meta itemprop="class" content="' + $node.attr('class') + '"/>');
      }
    });
    nodes = document.createTreeWalker(this.root, NodeFilter.SHOW_TEXT, null, null);
    while (node = nodes.nextNode()) {
      p = node.parentNode;
      text = node.nodeValue;
      $p = $(p);
      if ($p.closest('[data-analytics-ignore]')[0]) {
        continue;
      }
      $node = $(node);
      if ($p.attr('itemtype') === 'WebsiteLink') {
        if (!addedLinkEls.includes(p)) {
          content.content.push({
            '@type': 'WebsiteLink',
            text: $p.text(),
            id: $p.attr('id'),
            "class": $p.attr('class'),
            element: p
          });
          addedLinkEls.push(p);
        }
        continue;
      }
      if ((link = ($p.closest('[itemtype="WebsiteLink"]')[0])) != null) {
        $link = $(link);
        if (!addedLinkEls.includes(link)) {
          content.content.push({
            '@type': 'WebsiteLink',
            text: $link.text(),
            id: $link.attr('id'),
            "class": $link.attr('class'),
            element: link
          });
          addedLinkEls.push(link);
        }
        continue;
      }
      if (/^\s+$/.test(text)) {
        continue;
      }
      $p.attr('itemscope', '').attr('itemtype', 'WebsiteText').attr('itemprop', 'text');
      if ($p.attr('id')) {
        $p.prepend('<meta itemprop="id" content="' + $node.attr('id') + '"/>');
      }
      if ($p.attr('class')) {
        $p.prepend('<meta itemprop="class" content="' + $node.attr('class') + '"/>');
      }
      level = 5;
      textContent = {
        '@type': 'WebsiteText',
        text: text,
        id: $p.attr('id'),
        "class": $p.attr('class'),
        element: p
      };
      switch (p.tagName) {
        case 'H1':
          level = 1;
          textContent.level = 'h1';
          break;
        case 'H2':
          level = 2;
          textContent.level = 'h2';
          break;
        case 'H3':
          level = 3;
          textContent.level = 'h3';
          break;
        case 'H4':
          level = 4;
          textContent.level = 'h4';
          break;
        case 'SMALL':
          level = 6;
          textContent.level = 'small';
          break;
        default:
          level = 5;
          textContent.level = 'p';
      }
      content.content.push(textContent);
      $p.prepend('<meta itemprop="level" content="' + textContent.level + '"/>');
      if (level === topLevel && written) {
        json.content.push(content);
        content = {
          '@type': 'WebsiteContent',
          content: []
        };
        written = false;
      }
      written = true;
    }
    if (written) {
      json.content.push(content);
    }
    console.log('content', json);
    this.bindEvents();
  }

  Annotator.prototype.bindEvents = function() {
    var $root, scrollFn;
    $root = $(this.root);
    $root.on('mouseenter', '[itemscope]', function(e) {
      var $target, _selector, rect, ref, x, y;
      ref = get$targetAndSelector(e), $target = ref[0], _selector = ref[1];
      x = getScrollPosition[0], y = getScrollPosition[1];
      rect = e.target.getBoundingClientRect();
      return HanzoAnalytics('MouseEnter', {
        selector: _selector,
        type: $target.attr('itemtype'),
        mouseX: e.clientX,
        mouseY: e.clientY,
        scrollX: x,
        scrollY: y,
        contentX: rect.left,
        contentY: rect.top,
        viewportX: document.documentElement.clientHeight,
        viewportY: document.documentElement.clientWidth
      });
    });
    $root.on('mouseleave', '[itemscope]', function(e) {
      var $target, _selector, rect, ref, x, y;
      ref = get$targetAndSelector(e), $target = ref[0], _selector = ref[1];
      x = getScrollPosition[0], y = getScrollPosition[1];
      rect = e.target.getBoundingClientRect();
      return HanzoAnalytics('MouseLeave', {
        selector: _selector,
        type: $target.attr('itemtype'),
        mouseX: e.clientX,
        mouseY: e.clientY,
        scrollX: x,
        scrollY: y,
        contentX: rect.left,
        contentY: rect.top,
        viewportX: document.documentElement.clientHeight,
        viewportY: document.documentElement.clientWidth
      });
    });
    scrollFn = debounce((function(_this) {
      return function(e) {
        var $visible;
        $visible = $(_this.root).find('[itemscope]:visible');
        return $visible.each(function(i, el) {
          var _selector, rect, x, y;
          rect = el.getBoundingClientRect();
          if (!el._inViewport && isElementInViewport(rect)) {
            _selector = getSelector(el);
            x = getScrollPosition[0], y = getScrollPosition[1];
            console.log(_selector, 'entered viewport');
            HanzoAnalytics('ViewportEnter', {
              selector: _selector,
              type: $(el).attr('itemtype'),
              mouseX: e.clientX,
              mouseY: e.clientY,
              scrollX: x,
              scrollY: y,
              contentX: rect.left,
              contentY: rect.top,
              viewportX: document.documentElement.clientHeight,
              viewportY: document.documentElement.clientWidth
            });
            return el._inViewport = true;
          } else if (el._inViewport && !isElementInViewport(rect)) {
            _selector = getSelector(el);
            x = getScrollPosition[0], y = getScrollPosition[1];
            console.log(_selector, 'left viewport');
            HanzoAnalytics('ViewportLeave', {
              selector: _selector,
              type: $(el).attr('itemtype'),
              mouseX: e.clientX,
              mouseY: e.clientY,
              scrollX: x,
              scrollY: y,
              contentX: rect.left,
              contentY: rect.top,
              viewportX: document.documentElement.clientHeight,
              viewportY: document.documentElement.clientWidth
            });
            return el._inViewport = false;
          }
        });
      };
    })(this), 10, true);
    return $(window).on('DOMContentLoaded load resize scroll', scrollFn);
  };

  return Annotator;

})();

var Annotator$1 = Annotator;

// src/hero.coffee
var Hero,
  extend$4 = function(child, parent) { for (var key in parent) { if (hasProp$4.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$4 = {}.hasOwnProperty;

Hero = (function(superClass) {
  extend$4(Hero, superClass);

  function Hero() {
    Hero.__super__.constructor.apply(this, arguments);
  }

  return Hero;

})(Annotator$1);

var Hero$1 = Hero;

// src/block.coffee
var Block,
  extend$5 = function(child, parent) { for (var key in parent) { if (hasProp$5.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$5 = {}.hasOwnProperty;

Block = (function(superClass) {
  extend$5(Block, superClass);

  function Block() {
    Block.__super__.constructor.apply(this, arguments);
  }

  return Block;

})(Annotator$1);

var Block$1 = Block;

// src/cta.coffee
var CTA,
  extend$6 = function(child, parent) { for (var key in parent) { if (hasProp$6.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp$6 = {}.hasOwnProperty;

CTA = (function(superClass) {
  extend$6(CTA, superClass);

  function CTA() {
    CTA.__super__.constructor.apply(this, arguments);
  }

  return CTA;

})(Annotator$1);

// src/animate.coffee
var triggerDist;

triggerDist = 40;

$.fn.extend = function(obj) {
  return $.extend($.fn, obj);
};

$.fn.extend({
  animateCss: function(animationName, callback) {
    var animationEnd;
    animationEnd = (function(el) {
      var animations, t;
      animations = {
        animation: 'animationend',
        OAnimation: 'oAnimationEnd',
        MozAnimation: 'mozAnimationEnd',
        WebkitAnimation: 'webkitAnimationEnd'
      };
      for (t in animations) {
        if (el.style[t] !== void 0) {
          return animations[t];
        }
      }
    })(document.createElement('div'));
    this.addClass('animated ' + animationName).one(animationEnd, function() {
      $(this).removeClass('animated ' + animationName);
      if (typeof callback === 'function') {
        callback();
      }
    });
    return this;
  }
});

$(function() {
  var $scrollableArea, $window, fn;
  fn = function() {
    var height, ref, ref1, width;
    width = (ref = Math.max(document.documentElement.clientWidth, window.innerWidth)) != null ? ref : 0;
    height = (ref1 = Math.max(document.documentElement.clientHeight, window.innerHeight)) != null ? ref1 : 0;
    $('[data-animate-in]:not(.animated-in)').each(function() {
      var $el, el, rect;
      el = this;
      $el = $(el);
      rect = el.getBoundingClientRect();
      if (rect.top < height + triggerDist && rect.bottom > -triggerDist) {
        return $el.animateCss($el.attr('data-animate-in'), function() {
          return $el.addClass('animated-in');
        });
      }
    });
    return $('.animated-in').each(function() {
      var $el, el, rect;
      el = this;
      $el = $(el);
      rect = el.getBoundingClientRect();
      if (!$el.attr('data-animate-out')) {
        return;
      }
      if (rect.top >= height + triggerDist * 2 || rect.bottom <= triggerDist * -2) {
        return $el.animateCss($el.attr('data-animate-out'), function() {
          return $el.removeClass('animated-in');
        });
      }
    });
  };
  $window = $(window);
  $window.on('DOMContentLoaded scroll', fn);
  $scrollableArea = $('main');
  return $scrollableArea.on('DOMContentLoaded scroll', fn);
});

// src/index.coffee
var start, tagNames;

tagNames = [HeaderMenuComplex$1.prototype.tag.toUpperCase(), HeaderMenuMobile$1.prototype.tag.toUpperCase(), HeaderMenuSimple$1.prototype.tag.toUpperCase(), PrivacyPopup$1.prototype.tag.toUpperCase()];

var index = start = function(orgId, analyticsEnabled) {
  HanzoAnalytics.orgId = orgId;
  HanzoAnalytics.onFocus = function(record) {
    return console.log('Record', record);
  };
  HanzoAnalytics.flushRate = 10000;
  analyticsEnabled = !!analyticsEnabled;
  if (analyticsEnabled) {
    $('hero, .hero').each(function(i, el) {
      return new Hero$1(el);
    });
    $('block, .block').each(function(i, el) {
      return new Block$1(el);
    });
  }
  return El.mount(tagNames.join(','));
};

module.exports = index;
//# sourceMappingURL=astley.js.map
